org.apache.tomcat.dbcp.dbcp2

## Interface BasicDataSourceMXBean

All Known Implementing Classes:
  BasicDataSource, BasicManagedDataSource

    public interface BasicDataSourceMXBean

Defines the methods that will be made available via JMX.

Since:
  2.0

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods
`boolean` `getAbandonedUsageTracking()` See `BasicDataSource.getAbandonedUsageTracking()`
`boolean` `getCacheState()` See `BasicDataSource.getCacheState()`
`String[]` `getConnectionInitSqlsAsArray()` See `BasicDataSource.getConnectionInitSqlsAsArray()`
`Boolean` `getDefaultAutoCommit()` See `BasicDataSource.getDefaultAutoCommit()`
`String` `getDefaultCatalog()` See `BasicDataSource.getDefaultCatalog()`
`Boolean` `getDefaultReadOnly()` See `BasicDataSource.getDefaultReadOnly()`
`default String` `getDefaultSchema()` See `BasicDataSource.getDefaultSchema()`
`int` `getDefaultTransactionIsolation()` See `BasicDataSource.getDefaultTransactionIsolation()`
`String[]` `getDisconnectionSqlCodesAsArray()` See `BasicDataSource.getDisconnectionSqlCodesAsArray()`
`String` `getDriverClassName()` See `BasicDataSource.getDriverClassName()`
`boolean` `getFastFailValidation()` See `BasicDataSource.getFastFailValidation()`
`int` `getInitialSize()` See `BasicDataSource.getInitialSize()`
`boolean` `getLifo()` See `BasicDataSource.getLifo()`
`boolean` `getLogAbandoned()` See `BasicDataSource.getLogAbandoned()`
`boolean` `getLogExpiredConnections()` See `BasicDataSource.getLogExpiredConnections()`
`long` `getMaxConnLifetimeMillis()` See `BasicDataSource.getMaxConnLifetimeMillis()`
`int` `getMaxIdle()` See `BasicDataSource.getMaxIdle()`
`int` `getMaxOpenPreparedStatements()` See `BasicDataSource.getMaxOpenPreparedStatements()`
`int` `getMaxTotal()` See `BasicDataSource.getMaxTotal()`
`long` `getMaxWaitMillis()` See `BasicDataSource.getMaxWaitMillis()`
`long` `getMinEvictableIdleTimeMillis()` See `BasicDataSource.getMinEvictableIdleTimeMillis()`
`int` `getMinIdle()` See `BasicDataSource.getMinIdle()`
`int` `getNumActive()` See `BasicDataSource.getNumActive()`
`int` `getNumIdle()` See `BasicDataSource.getNumIdle()`
`int` `getNumTestsPerEvictionRun()` See `BasicDataSource.getNumTestsPerEvictionRun()`
`String` `getPassword()` See `BasicDataSource.getPassword()`
`boolean` `getRemoveAbandonedOnBorrow()` See `BasicDataSource.getRemoveAbandonedOnBorrow()`
`boolean` `getRemoveAbandonedOnMaintenance()` See `BasicDataSource.getRemoveAbandonedOnMaintenance()`
`int` `getRemoveAbandonedTimeout()` See `BasicDataSource.getRemoveAbandonedTimeout()`
`long` `getSoftMinEvictableIdleTimeMillis()` See `BasicDataSource.getSoftMinEvictableIdleTimeMillis()`
`boolean` `getTestOnBorrow()` See `BasicDataSource.getTestOnBorrow()`
`boolean` `getTestOnCreate()` See `BasicDataSource.getTestOnCreate()`
`boolean` `getTestWhileIdle()` See `BasicDataSource.getTestWhileIdle()`
`long` `getTimeBetweenEvictionRunsMillis()` See `BasicDataSource.getTimeBetweenEvictionRunsMillis()`
`String` `getUrl()` See `BasicDataSource.getUrl()`
`String` `getUsername()` See `BasicDataSource.getUsername()`
`String` `getValidationQuery()` See `BasicDataSource.getValidationQuery()`
`int` `getValidationQueryTimeout()` See `BasicDataSource.getValidationQueryTimeout()`
`boolean` `isAccessToUnderlyingConnectionAllowed()` See `BasicDataSource.isAccessToUnderlyingConnectionAllowed()`
`default boolean` `isClearStatementPoolOnReturn()` See `BasicDataSource.isClearStatementPoolOnReturn()`
`boolean` `isClosed()` See `BasicDataSource.isClosed()`
`boolean` `isPoolPreparedStatements()` See `BasicDataSource.isPoolPreparedStatements()`
`default void` `restart()` See `BasicDataSource.restart()`
`default void` `start()` See `BasicDataSource.start()`

### Method Detail

#### getAbandonedUsageTracking

    boolean getAbandonedUsageTracking()

See `BasicDataSource.getAbandonedUsageTracking()`

Returns:
  `BasicDataSource.getAbandonedUsageTracking()`

#### getDefaultAutoCommit

    Boolean getDefaultAutoCommit()

See `BasicDataSource.getDefaultAutoCommit()`

Returns:
  `BasicDataSource.getDefaultAutoCommit()`

#### getDefaultReadOnly

    Boolean getDefaultReadOnly()

See `BasicDataSource.getDefaultReadOnly()`

Returns:
  `BasicDataSource.getDefaultReadOnly()`

#### getDefaultTransactionIsolation

    int getDefaultTransactionIsolation()

See `BasicDataSource.getDefaultTransactionIsolation()`

Returns:
  `BasicDataSource.getDefaultTransactionIsolation()`

#### getDefaultCatalog

    String getDefaultCatalog()

See `BasicDataSource.getDefaultCatalog()`

Returns:
  `BasicDataSource.getDefaultCatalog()`

#### getDefaultSchema

    default String getDefaultSchema()

See `BasicDataSource.getDefaultSchema()`

Returns:
  `BasicDataSource.getDefaultSchema()`
Since:
  2.5.0

#### getCacheState

    boolean getCacheState()

See `BasicDataSource.getCacheState()`

Returns:
  `BasicDataSource.getCacheState()`

#### getDriverClassName

    String getDriverClassName()

See `BasicDataSource.getDriverClassName()`

Returns:
  `BasicDataSource.getDriverClassName()`

#### getLifo

    boolean getLifo()

See `BasicDataSource.getLifo()`

Returns:
  `BasicDataSource.getLifo()`

#### getMaxTotal

    int getMaxTotal()

See `BasicDataSource.getMaxTotal()`

Returns:
  `BasicDataSource.getMaxTotal()`

#### getMaxIdle

    int getMaxIdle()

See `BasicDataSource.getMaxIdle()`

Returns:
  `BasicDataSource.getMaxIdle()`

#### getMinIdle

    int getMinIdle()

See `BasicDataSource.getMinIdle()`

Returns:
  `BasicDataSource.getMinIdle()`

#### getInitialSize

    int getInitialSize()

See `BasicDataSource.getInitialSize()`

Returns:
  `BasicDataSource.getInitialSize()`

#### getMaxWaitMillis

    long getMaxWaitMillis()

See `BasicDataSource.getMaxWaitMillis()`

Returns:
  `BasicDataSource.getMaxWaitMillis()`

#### isPoolPreparedStatements

    boolean isPoolPreparedStatements()

See `BasicDataSource.isPoolPreparedStatements()`

Returns:
  `BasicDataSource.isPoolPreparedStatements()`

#### isClearStatementPoolOnReturn

    default boolean isClearStatementPoolOnReturn()

See `BasicDataSource.isClearStatementPoolOnReturn()`

Returns:
  `BasicDataSource.isClearStatementPoolOnReturn()`
Since:
  2.8.0

#### getMaxOpenPreparedStatements

    int getMaxOpenPreparedStatements()

See `BasicDataSource.getMaxOpenPreparedStatements()`

Returns:
  `BasicDataSource.getMaxOpenPreparedStatements()`

#### getTestOnCreate

    boolean getTestOnCreate()

See `BasicDataSource.getTestOnCreate()`

Returns:
  `BasicDataSource.getTestOnCreate()`

#### getTestOnBorrow

    boolean getTestOnBorrow()

See `BasicDataSource.getTestOnBorrow()`

Returns:
  `BasicDataSource.getTestOnBorrow()`

#### getTimeBetweenEvictionRunsMillis

    long getTimeBetweenEvictionRunsMillis()

See `BasicDataSource.getTimeBetweenEvictionRunsMillis()`

Returns:
  `BasicDataSource.getTimeBetweenEvictionRunsMillis()`

#### getNumTestsPerEvictionRun

    int getNumTestsPerEvictionRun()

See `BasicDataSource.getNumTestsPerEvictionRun()`

Returns:
  `BasicDataSource.getNumTestsPerEvictionRun()`

#### getMinEvictableIdleTimeMillis

    long getMinEvictableIdleTimeMillis()

See `BasicDataSource.getMinEvictableIdleTimeMillis()`

Returns:
  `BasicDataSource.getMinEvictableIdleTimeMillis()`

#### getSoftMinEvictableIdleTimeMillis

    long getSoftMinEvictableIdleTimeMillis()

See `BasicDataSource.getSoftMinEvictableIdleTimeMillis()`

Returns:
  `BasicDataSource.getSoftMinEvictableIdleTimeMillis()`

#### getTestWhileIdle

    boolean getTestWhileIdle()

See `BasicDataSource.getTestWhileIdle()`

Returns:
  `BasicDataSource.getTestWhileIdle()`

#### getNumActive

    int getNumActive()

See `BasicDataSource.getNumActive()`

Returns:
  `BasicDataSource.getNumActive()`

#### getNumIdle

    int getNumIdle()

See `BasicDataSource.getNumIdle()`

Returns:
  `BasicDataSource.getNumIdle()`

#### getPassword

    String getPassword()

See `BasicDataSource.getPassword()`

Returns:
  `BasicDataSource.getPassword()`

#### getUrl

    String getUrl()

See `BasicDataSource.getUrl()`

Returns:
  `BasicDataSource.getUrl()`

#### getUsername

    String getUsername()

See `BasicDataSource.getUsername()`

Returns:
  `BasicDataSource.getUsername()`

#### getValidationQuery

    String getValidationQuery()

See `BasicDataSource.getValidationQuery()`

Returns:
  `BasicDataSource.getValidationQuery()`

#### getValidationQueryTimeout

    int getValidationQueryTimeout()

See `BasicDataSource.getValidationQueryTimeout()`

Returns:
  `BasicDataSource.getValidationQueryTimeout()`

#### getConnectionInitSqlsAsArray

    String[] getConnectionInitSqlsAsArray()

See `BasicDataSource.getConnectionInitSqlsAsArray()`

Returns:
  `BasicDataSource.getConnectionInitSqlsAsArray()`

#### isAccessToUnderlyingConnectionAllowed

    boolean isAccessToUnderlyingConnectionAllowed()

See `BasicDataSource.isAccessToUnderlyingConnectionAllowed()`

Returns:
  `BasicDataSource.isAccessToUnderlyingConnectionAllowed()`

#### getMaxConnLifetimeMillis

    long getMaxConnLifetimeMillis()

See `BasicDataSource.getMaxConnLifetimeMillis()`

Returns:
  `BasicDataSource.getMaxConnLifetimeMillis()`

#### getLogExpiredConnections

    boolean getLogExpiredConnections()

See `BasicDataSource.getLogExpiredConnections()`

Returns:
  `BasicDataSource.getLogExpiredConnections()`
Since:
  2.1

#### getRemoveAbandonedOnBorrow

    boolean getRemoveAbandonedOnBorrow()

See `BasicDataSource.getRemoveAbandonedOnBorrow()`

Returns:
  `BasicDataSource.getRemoveAbandonedOnBorrow()`

#### getRemoveAbandonedOnMaintenance

    boolean getRemoveAbandonedOnMaintenance()

See `BasicDataSource.getRemoveAbandonedOnMaintenance()`

Returns:
  `BasicDataSource.getRemoveAbandonedOnMaintenance()`

#### getRemoveAbandonedTimeout

    int getRemoveAbandonedTimeout()

See `BasicDataSource.getRemoveAbandonedTimeout()`

Returns:
  `BasicDataSource.getRemoveAbandonedTimeout()`

#### getLogAbandoned

    boolean getLogAbandoned()

See `BasicDataSource.getLogAbandoned()`

Returns:
  `BasicDataSource.getLogAbandoned()`

#### isClosed

    boolean isClosed()

See `BasicDataSource.isClosed()`

Returns:
  `BasicDataSource.isClosed()`

#### getFastFailValidation

    boolean getFastFailValidation()

See `BasicDataSource.getFastFailValidation()`

Returns:
  `BasicDataSource.getFastFailValidation()`
Since:
  2.1

#### getDisconnectionSqlCodesAsArray

    String[] getDisconnectionSqlCodesAsArray()

See `BasicDataSource.getDisconnectionSqlCodesAsArray()`

Returns:
  `BasicDataSource.getDisconnectionSqlCodesAsArray()`
Since:
  2.1

#### start

    default void start()
                throws SQLException

See `BasicDataSource.start()`

Throws:
  `SQLException` - if an error occurs initializing the datasource
Since:
  2.8.0

#### restart

    default void restart()
                  throws SQLException

See `BasicDataSource.restart()`

Throws:
  `SQLException` - if an error occurs initializing the datasource
Since:
  2.8.0